=== test/python/Makefile ===
CFLAGS=
LDFLAGS=

BIN=

all: $(BIN)

%: %.c
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS)

test: $(BIN)
	./run.sh
clean:
	rm -f $(BIN)
