=== src/modules/kokkos/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.19)
include(CheckSourceCompiles)

PROJECT(eztrace-kokkos CXX)

find_package (Kokkos REQUIRED)

add_library(eztrace-kokkos SHARED
  kokkos.cpp
)

target_link_libraries(eztrace-kokkos
  PRIVATE
    atomic
    dl
    eztrace-core
    eztrace-lib
    eztrace-instrumentation
    Kokkos::kokkos
   )

target_include_directories(eztrace-kokkos
  PRIVATE
  ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
  Kokkos::kokkos
)

set_target_properties(eztrace-kokkos PROPERTIES LINKER_LANGUAGE CXX)

#---------------------------------------------

install(TARGETS eztrace-kokkos
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)
