=== debian/changelog ===
eztrace (2.2.1-5) unstable; urgency=medium

  * control, rules: Disable kokkos for now.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 02 Sep 2025 21:14:01 +0200

eztrace (2.2.1-4) unstable; urgency=medium

  * tests/control: Add MPI smoke test.
  * patches/mpi_core: Fix mpich/openmpi MPI build conflict.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 28 Aug 2025 12:07:25 +0200

eztrace (2.2.1-3) unstable; urgency=medium

  * control: Disable libpnetcdf-dev build-dependency on 32bit archs instead of
    enabling it on 64bit archs.
  * rules: Disable pnetcdf on 32bit archs instead of enabling it on an explicit
    list.
  * rules: Disable kokkos on archs where it fails to build.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 16 Aug 2025 09:45:48 +0200

eztrace (2.2.1-2) unstable; urgency=medium

  * control: Avoid build-depending on kokkos where it failed to build.
  * patches/starpu-hip: Fix building against starpu with hip support.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 16 Aug 2025 01:07:02 +0200

eztrace (2.2.1-1) unstable; urgency=medium

  * New upstream Release.
    - control: Bump cmake build-dep version accordingly.
    - control: Build-Depend on libkokkos-dev, python3, libpython3-dev.
    - control: Make eztrace depend on python3.
    - eztrace.lintian-overrides: Suppress lintian warning.
    - patches/kokkos_openmp: Fix OpenMP detection for kokkos.
    - patches/eztrace.py: Fix running python tests.
    - patches/fortran-no-mpi: Fix build with fortran but no mpi.
    - patches/mpi_mode: Fix running mpi tests.
    - patches/eztrace.py.version: Ensure to run with python3.
    - patches/CXXFLAGS: Fix taking CXXFLAGS into account.
    - patches/otf2: Fix detecting newer otf2 release.
    - rules: Enable kokkos and python backends.
    - rules: Drop cleaning source, bug #64 fixed upstream.
    - libeztrace0.lintian-overrides: Update.
  * copyright: Update.
  * Update standards version to 4.6.2, no changes needed.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 14 Aug 2025 23:10:04 +0200

eztrace (2.1.1-6) unstable; urgency=medium

  * rules: Make smoketest failure abort immediately, and add comment.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 29 Apr 2025 15:44:45 +0200
